; 
;                         Build as CONSOLE app
; 

    .486
    .model flat, stdcall
    option casemap :none   ; case sensitive

; 

    include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\masm32.inc
    include \masm32\macros\macros.asm
    include repequ.inc

    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\masm32.lib
    includelib repequ.lib

    .code

start:

; 

    call main

    invoke ExitProcess,0

; 

main proc

    LOCAL fname1:DWORD
    LOCAL fname2:DWORD
    LOCAL fname3:DWORD
    LOCAL pMem1 :DWORD
    LOCAL pMem2 :DWORD
    LOCAL pMem3 :DWORD
    LOCAL flen  :DWORD
    LOCAL buffer1[260]:BYTE 
    LOCAL buffer2[260]:BYTE 
    LOCAL buffer3[260]:BYTE 

    mov fname1, ptr$(buffer1)
    mov fname2, ptr$(buffer2)
    mov fname3, ptr$(buffer3)

    invoke GetCL,1,fname1
    invoke exist,fname1
    cmp eax, 0
    jne @F
    print chr$("Missing first argument 'word file'",13,10)
    call help
  @@:

    invoke GetCL,2,fname2
    invoke exist,fname2
    cmp eax, 0
    jne @F
    print chr$("Missing second argument 'source file'",13,10)
    call help
  @@:

    invoke GetCL,3,fname3
    cmp eax, 2
    jne @F
    print chr$("Missing third argument 'target file'",13,10)
    call help
  @@:

    mov pMem1, InputFile(fname1)
    mov pMem2, InputFile(fname2)

    invoke replace_words,pMem1,pMem2    ; call procedure in DLL
    mov pMem3, eax                      ; save the memory pointer

    mov eax, OutputFile(fname3,pMem3,len(pMem3))

  quit:

    free pMem1
    free pMem2
    free pMem3

    ret

main endp

; 

help proc

    print chr$("WREP : 'Word Replace' Copyright (c) MASM32 1998-2004",13,10,13,10)
    print chr$("ARGUMENTS",13,10)
    print chr$("  1. File with word pairs 'this that' or 'this = that'",13,10)
    print chr$("  2. Source file to replace word in",13,10)
    print chr$("  3. Target file to write results to",13,10,13,10)
    print chr$("EXAMPLE : wrep myequate.equ mysource.asm myresult.asm",13,10)

    invoke ExitProcess,0

    ret

help endp

; 

end start